# &arts;-verktyg

Ett antal verktyg levereras tillsammans med &arts; för att styra och anpassa dess beteende. Du behöver känna till de flesta av de här verktygen lite grand för att kunna använda &arts; på ett effektivt sätt. Det här avsnittet beskriver vart och en av verktygen och deras kommandoväljare.

## Inställningscentralen

När man kör &arts; med &kde;, tillhandahåller inställningscentralen en grupp med inställningar i kategorin Ljud. Vissa av de här används av &arts;. Man kan också binda ljud till olika fönsterhanterings- och &kde;-händelser med dialogrutan LjudSystemunderrättelser. Se handboken för inställningscentralen för mer information om hur dialogrutans inställningar används.

## &artsd;

Tillgången till ljudhårdvaran kontrolleras av &artsd;, ljudservern för &arts;. Det här tillåter att flera program samtidigt skickar en begäran till servern, där de kan blandas och spelas upp. Utan en central ljudserver skulle ett enstaka program som använder en ljudenhet förhindra andra program från att använda den.

För att använda &arts; ska det finnas en och endast en kopia av &artsd; som kör. Den startas typiskt när &kde; startas om detta är aktiverat i inställningscentralens Ljudserver modul.

Programmet accepterar följande väljare:

    artsd  -n -p -N -W n   -a audiomethod -r sampling rate -b bits -d -D devicename -F fragments -S size -s seconds -m appName   -h -A -v -l level

`-r sampling rate`

  Ställ in samplingsfrekvens som ska användas.

`-h`

  Visa kommandoanvändning.

`-n`

  Aktivera nätverkstransparens.

`-p port`

  Ange TCP-port som ska användas (förutsätter `-n`).

`-u`

  Öppen, ingen identifiering (farligt).

`-d`

  Aktivera full duplex.

`-D devicename`

  Ange ljudenhet (vanligtvis `/dev/dsp`).

`-F fragments`

  Ange antal fragment.

`-S size`

  Ange fragmentstorlek i byte.

`-s seconds`

  Ställ in fördröjningen innan vänteläget aktiveras i sekunder. Värdet noll stänger av vänteläget.

`-m appName`

  Ange namnet på ett program som används för att visa fel, varningar och informationsmeddelanden. Om du kör KDE kan du använda verktyget artsmessage för det här.

`-N`

  Öka storleken av nätverksbuffrarna till ett värde som är lämpligt för att köra med ett 10 Mbps lokalt nätverk. Det här är samma som att använda väljaren -w 5 (se nedan).

`-w n`

  När artsd körs via en nätverksanslutning till en annan värddator vill man ofta använda en stor buffer för att undvika pauser. aRts föreslår en minimal bufferstorlek för program. Utan det här alternativet baseras den förvalda storleken på fragmentstorleken * antalet fragment. Med det här alternativet kan man öka storleken från den förvalda med en faktor n.

`-l level`

  Ställ in informationsnivå: 3 (tyst), 2 (varningar), 1 (info), 0 (avlusning).

`-v`

  Visa versionsnivå.

I de flesta fall är det nog att bara köra &artsd;.

## &artswrapper;

För att ge bra realtidsegenskaper körs &artsd; oftast som en realtidsprocess (på plattformar där realtidsprioriteter stöds). Det här kräver root-behörighet, så för att minimera säkerhetspåverkan, kan &artsd; startas med det lilla omgärdande programmet &artswrapper; som helt enkelt byter till realtidsprioritet (medan det kör som root) och sedan startar &artsd; som en annan användare än root.

Om du gör &artswrapper; SUID root, kommer det troligen förbättra kvaliteten på ljudåtergivningen genom att reducera uppehåll i musiken. Dock ökar det också risken att ett fel i koden, eller en användare med uppsåt att skada kan krascha eller skada datorn på något sätt. Dessutom, att prioritera hög ljudkvalitet på fleranvändardatorer kan orsaka försämrad prestanda för användare som försöker använda datorn på ett produktivt sätt.

## &artsshell;

Kommandot &artsshell; är avsett som ett verktyg för att utföra diverse funktioner som hör ihop med ljudservern. Förmodligen kommer verktyget att utökas med nya kommandon i framtiden (se kommentarerna i källkoden för några idéer).

Kommandot accepterar följande format:

    artsshell  suspendstatus terminate autosuspend secs networkbuffers n volume [volume] stereoeffect options   -h -q

artsshell [väljare] kommando [kommandoalternativ]

Följande väljare stöds:

`-q`

  Undertryck all utmatning.

`-h`

  Visa kommandoanvändning.

Följande kommandon stöds:

`suspend`

  Ange att ljudservern ska gå till vänteläget.

`status`

  Visa statusinformation för ljudservern.

`terminate`

  Avsluta ljudservern. Det här kan förvirra och/eller krascha alla program som för närvarande använder den.

`autosuspend` `secs`

  Ställ in fördröjningen för aktivering av vänteläget till det angivna antalet sekunder. Ljudservern går till vänteläget om den är inaktiv så länge. Värdet noll stänger av vänteläget.

`networkbuffers` `n`

  Ställer in storleken på nätverksbuffrarna till en faktor `n` gånger den förvalda storleken.

`volume` [volume]

  Ställer in volymskalning för ljudserverns utmatning av ljud. Parametern volume är ett flyttal. Utan parameter visas nuvarande volym.

`stereoeffect list`

  Visa alla tillgängliga stereoeffektmodulerna.

`stereoeffect insert [top|bottom]` namn

  Infoga en stereoeffekt i stereoeffektstacken. Returnerar en identifierare som senare kan användas för att ta bort den. Effekten kan installeras längst upp eller längs ner (normalvärdet).

`stereoeffect remove` id

  Tar bort stereoeffekten med identifieraren id från effektstacken.

## artsplay

Programmet artsplay är ett enkelt verktyg för att spela en ljudfil. Det accepterar en enda parameter som motsvarar namnet på ljudfilen som skickas till ljudservern för att spelas. Ljudfilen kan vara vilken vanlig ljudfiltyp som helst, såsom `wav` eller `au`. Det här verktyget är bra för att prova om ljudservern fungerar. Genom att köra två kommandon parallellt eller i snabb följd kan man demonstrera hur ljudservern blandar mer än en ljudkälla.

## artsdsp

Ljudservern hanterar bara program som stöder &arts;. Många gamla program vill komma åt ljudenheten direkt. Kommandot &artsdsp; tillhandahåller en interimlösning som låter de flesta av dessa program köra oförändrade.

När ett program körs med &artsdsp; fångas alla försök att komma åt ljudenheten `/dev/dsp` och omvandlas till anrop till &arts; programmeringsgränssnitt. Även om enhetsemuleringen inte är perfekt, så fungerar de flesta program på det här sättet, fastän med en viss försämring i prestanda och latenstid.

Kommandot &artsdsp; följer formatet:

artsdsp [väljare] program väljare

Följande väljare känns igen:

`-h`, `--help`

  Visa kortfattad hjälp.

`-n` `--name` = namn

  Använd namn för att identifiera en spelare för `artsd`.

`-m` `--mmap`

  Emulera minnesmappning (t.ex för Quake).

`-v` `--verbose`

  Visa väljare.

Ett typiskt anrop är:

``artsdsp` `-v` `-m` `realplay song.mp3``

Vissa program fungerar bättre med väljaren `--mmap`. Ljudenhetens alla funktioner är inte fullständigt emulerade, men de flesta program bör fungera. Om du hittar ett som inte gör det, skicka in en detaljerad felrapport så kan utvecklarna fixa det. Återigen, kom ihåg att det här är en intermediär lösning och något av en ful snabbfix. Den bästa lösningen är att lägga till inbyggt stöd för &arts; i programmen. Om ditt favoritljudprogram inte har stöd för &arts;, be utvecklaren att tillhandahålla det.

## artscat

Det här är ett enkelt verktyg för att skicka råljuddata till ljudservern. Man måste ange dataformatet (samplingsfrekvens, samplingsstorlek och antal kanaler). Det här är troligen inte ett verktyg som man behöver använda ofta, men det kan vara bekvämt för provändamål. Kommandosyntaxen är:

artscat [ väljare ] [ filnamn ]

Om inget filnamn anges läser programmet från standardinmatningen. Följande väljare stöds:

`-r` `samplingsfrekvens`

  Ställ in samplingsfrekvens som används.

`-b` `bitar`

  Ställ in samplingsstorlek som används (8 eller 16).

`-c` `kanaler`

  Välj antal kanaler (1 eller 2).

`-h`

  Visa kommandoanvändning och avsluta.

## &artscontrol;

Det här är ett grafiskt verktyg för att utföra ett antal uppgifter som hör ihop med ljudservern. Det förvalda fönstret visar två volymnivåvisare och ett skjutreglage för att ställa in den generella uppspelningsvolymen. Från menyn Visa kan du välja andra funktioner:

FFT-mätare

  Öppnar ett fönster som visar en skärm med en realtidsspektrumanalysator.

Ljudhanterare

  Visar aktiva ljudkällor och låter dig ansluta dem till alla tillgängliga bussar.

aRts status

  Visar om ljudservern kör och om realtidsschemaläggning används. Anger när servern kommer att gå till vänteläget och låter dig gå till vänteläget omedelbart.

Midihanterare

  Visar aktiva &MIDI; in- och utgångar och låter dig göra förbindelser [ATT GÖRA: fungerar det här ännu? Behöver mera detaljer].

FreeVerb

  Ansluter en FreeVerb efterklangseffekt till stacken av &arts; utmatningseffekter och låter dig kontrollera ljudeffektinställningarna grafiskt.

Leds liknande volymvisning

  Ändrar volymindikeringen i huvudfönstret att använda ett visningsformat med färgade lysdioder istället för staplar.

## artsc-config

Det här verktyget är till för att hjälpa utvecklare som använder C-programmeringsgränssnittet i &arts;. Det matar ut de riktiga kompilator- och länkarväljare som behövs när man kompilerar och länkar med &arts;. Det är tänkt att användas i make-filer för att hjälpa till med flyttbarhet. Kommandot accepterar tre väljare:

`--cflags`

  Visar kompilatorväljare som behövs när man kompilerar med &arts; C-programmeringsgränssnitt.

`--libs`

  Visar länkarväljare som behövs när man länkar med &arts; C-programmeringsgränssnitt.

---version

  Visar versionen av kommandot `artsc-config`.

Typisk utmatning från kommandot visas nedan:

    % artsc-config --cflags
    -I/usr/local/kde2/include/artsc
    % artsc-config --libs
    -L/usr/local/kde2/lib -ldl -lartsc -DPIC -fPIC -lpthread
    % artsc-config --version
    0.9.5

Man ska kunna använda det här verktyget i en make-fil med en regel som:

    artsc: artsc.c
            gcc `artsc-config --cflags` -o artsc artsc.c `artsc-config --libs`

## &mcopidl;

Kommandot &mcopidl; är &IDL;-fil kompilatorn för &MCOP;, multimedia-kommunikationsprotokollet som används av &arts;. Gränssnitt i &arts; definieras med &IDL;, ett språkoberoende gränssnittsdefinitionsspråk. Verktyget &mcopidl; accepterar en &IDL;-fil som indata och skapar C++ deklarations- och källkodsfiler för en klass som implementerar gränssnittet. Kommandot accepterar följande syntax:

mcopidl [ väljare ] filnamn

Giltiga väljare är:

`-I` `katalog`

  Sök i `katalog` efter deklarationsfiler.

`-e` `namn`

  Hoppa över en struct, gränssnitt eller uppräkningstyp `namn` vid kodgenerering.

`-t`

  Skapa också `.mcoptype`/`.mcopclass` filer som innehåller typinformation för &IDL;-filen.

Mer information om &MCOP; och &IDL; finns i avsnittet Gränssnitt och &IDL;.